
const MAIN_NOTICE_GRID_ID = '#ITP_MAIN_NOTICE_jqGrid';
const MAIN_NOTICE_GRID_LIST = '#ITP_MAIN_NOTICE_jqGrid_list';
const MAIN_NOTICE_GRID_PAGER = '#ITP_MAIN_NOTICE_jqGridPager';
const MAIN_NOTICE_GRID_EMPTY = '#ITP_MAIN_NOTICE_jqGridEmpty';

let NTICE_DETAIL_GRID_LIST = '/api/ntice/main-detail-grid-list';
let MAIN_CHART_PCH_REQ_CHART = '/api/main/chart/pch-req-chart';
let MAIN_CHART_PCH_ODR_CHART = '/api/main/chart/pch-odr-chart';
let MAIN_CHART_PR_RANK_CHART = '/api/main/chart/pr-rank-chart';
let MAIN_CHART_STL_CHART = '/api/main/chart/stl-chart';
let MAIN_CHART_SFT_STCK_CHART = '/api/main/chart/sft-stck-chart';

require(['config'], function() {
	require([
		'jquery', 
		'jquery.bootstrap.fileUpload' //파일 업로드가 있는 페이지에서 로딩
	], function($) {
		
		setTimeout(function() {
			// 시간지정
			// $('#ITP_FORM_MAIN_NOTICE_SEARCH_SCH_DT').val(itp_fn_date_format(new Date(), 2));
			// $('#ITP_FORM_MAIN_NOTICE_SEARCH_USER_ID').val(fn_make_user_info.get('userId'));
			
			// 그리드
			// itp_fn_MAIN_NOTICE_grid.init();
	    	// itp_fn_fire_window_resize();

			// 조회
	    	itp_fn_MAIN_NOTICE_search();		

		}, 300);
		
		$('#ITP_FORM_MAIN_SEARCH_PR_TYPE').on('change', function() {
			drawChartReq();
		});
		
		$('#ITP_FORM_MAIN_SEARCH_PO_TYPE').on('change', function() {
			drawChartPodr();
		});
		
		$('#ITP_FORM_MAIN_SEARCH_ITEM_CNT_TYPE').on('change', function() {
			drawChartReqUp();
		});
		
		//그래프 
		google.charts.load('current', {'packages':['corechart']});
		google.charts.load('current', {'packages':['bar']});
		
		var authTpCd = fn_make_user_info.get('authTpCd'); // 10:관리자, 20:영업담당자, 30:가맹점, 40:브랜드, 50:매장, 60:공급사
		
		if( authTpCd == '40' ) {  
			google.charts.setOnLoadCallback(drawChartReq); // 구매요청	
		}
		if( authTpCd == '40' ) {
			google.charts.setOnLoadCallback(drawChartPodr); // 구매발주	
		}
		if( authTpCd == '40' ) {
			google.charts.setOnLoadCallback(drawChartReqUp); // 매출순위 	
		}
		if( authTpCd == '40' ) {
			google.charts.setOnLoadCallback(drawChartcore); // 정산	
		}
		if( authTpCd == '40' ) {
			google.charts.setOnLoadCallback(drawLine); // 안전재고 	
		}
	});
});

//구매요청 그래프
function drawChartReq() {
	
	const key = { brandId:fn_make_user_info.get('brandId'), storeId:fn_make_user_info.get('storeId'), prType: $('#ITP_FORM_MAIN_SEARCH_PR_TYPE').val() };
	var param = $.param(key);
	fn_ajax_call(MAIN_CHART_PCH_REQ_CHART, param, function(result) {
		
		var data = google.visualization.arrayToDataTable( eval(result.chartData) );
	  	var options = {
			legend: { position: 'left' }
	  	};	
	  	var chart = new google.charts.Bar(document.getElementById('ITP_PCH_REQ_GRAPH'));
	  	chart.draw(data, options);
		
	}, 'GET');
	
}

//구매발주 그래프
function drawChartPodr() {
	
	const key = { brandId:fn_make_user_info.get('brandId'), storeId:fn_make_user_info.get('storeId'), poType: $('#ITP_FORM_MAIN_SEARCH_PO_TYPE').val() };
	var param = $.param(key);
	fn_ajax_call(MAIN_CHART_PCH_ODR_CHART, param, function(result) {
		
		var data = google.visualization.arrayToDataTable( eval(result.chartData) );
	
		  var options = {
		    	legend: { position: 'left' }	
		  };	
		  var chart = new google.charts.Bar(document.getElementById('ITP_PCH_PODR_GRAPH'));	
		  chart.draw(data, options);
		
	}, 'GET');	
	  
}

//구매요청 상위 품목 그리드
function drawChartReqUp() {
	
	const key = { brandId:fn_make_user_info.get('brandId'), storeId:fn_make_user_info.get('storeId'), prType: $('#ITP_FORM_MAIN_SEARCH_ITEM_CNT_TYPE').val() };
	var param = $.param(key);
	fn_ajax_call(MAIN_CHART_PR_RANK_CHART, param, function(result) {
		
		var data = google.visualization.arrayToDataTable( eval(result.chartData) );

		var options = {
			title: '구매요청 상위 품목',
			legend: { position: 'left' },
			bars: 'horizontal'
		};
		
		var chart = new google.charts.Bar(document.getElementById('ITP_PCH_REQ_UP_ITEM_GRAPH'));		
		chart.draw(data, options);
		
	}, 'GET');
	
}

//정산 그래프
function drawChartcore() {
	
	const key = { brandId:fn_make_user_info.get('brandId'), storeId:fn_make_user_info.get('storeId') };
	var param = $.param(key);
	fn_ajax_call(MAIN_CHART_STL_CHART, param, function(result) {
		
		// var data = google.visualization.arrayToDataTable([ [' ', ' '], ['요청', 25], ['확인', 65], ['반려', 10] ]);
		var data = google.visualization.arrayToDataTable( eval(result.chartData) );
	
	    var options = {
			// title: '정산',
			legend: { position: 'left' }	
	    };
	
	    var chart = new google.visualization.PieChart(document.getElementById('ITP_STTL_GRAPH'));	
	    chart.draw(data, options);				
		
	}, 'GET');
    
}


function drawLine() {

	const key = { brandId:fn_make_user_info.get('brandId'), storeId:fn_make_user_info.get('storeId') };
	var param = $.param(key);
	fn_ajax_call(MAIN_CHART_SFT_STCK_CHART, param, function(result) {
		
		var data = google.visualization.arrayToDataTable( eval(result.chartData) );
		
		var options = {
		    title: '',
		    width: 900,
		    legend: { position: 'top' }
		};
		
		var chart = new google.visualization.LineChart(document.getElementById('ITP_SAFE_STCK_GRAPH'));		
		chart.draw(data, options);
		
	}, 'GET');	
  
}

var itp_fn_MAIN_NOTICE_search = function() {
	// itp_fn_MAIN_NOTICE_grid.unload();
	// itp_fn_MAIN_NOTICE_grid.callBack();
	// 공지사항 조회
	const formId = '#ITP_FORM_MAIN_SEARCH';
	let param = $(formId).serializeObject();
	var searhFn = function(result) {
		$.each(result.gridRows, function(idx, value) {
		
			$('#ITP_NOTE_BAR').append($('#ITP_NOTE_ROWCOPY').val());			
			$('#ITP_NOTE_BAR .itp_side_bar_note:last').find('.fnTitle').html(value.nticeTitl);
			$('#ITP_NOTE_BAR .itp_side_bar_note:last').find('.fnDate').html(value.addDt);
			$('#ITP_NOTE_BAR .itp_side_bar_note:last').find('.fnContents').html(value.nticeDesc);
			
		});
	};
	fn_ajax_call(NTICE_DETAIL_GRID_LIST, JSON.stringify(param), searhFn, 'POST');
};

